/*
 * Copyright 2006 KonaWorks
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.konaworks.idea.modulegrouping;

import com.intellij.openapi.module.Module;
import com.intellij.openapi.util.text.StringUtil;

public class GroupByTypeDistributor extends AbstractGroupByDistributor {
  protected String getGroupName(Module module) {
    final String typeName = module.getModuleType().getName();
    if (typeName == null) {
      // All idea module types have names, but a custom module type might not...
      return null;
    }
    if (StringUtil.endsWithIgnoreCase(typeName, "module")) {
      return typeName.substring(0, typeName.length() - "module".length()).trim();
    } else {
      return typeName;
    }
  }
}
