package com.konaworks.idea.modulegrouping;

import junit.framework.Assert;
import junit.framework.TestCase;

public class GroupByNamePartDistributorTest extends TestCase {

  public void testGetPrefixWithLength() {

    Assert.assertEquals("1a", "get", GroupByNamePartDistributor.getPrefixWithLength("getWords", 1));
    Assert.assertEquals("1b", "getMore", GroupByNamePartDistributor.getPrefixWithLength("getMoreWords", 2));
    Assert.assertEquals("1c", "getEvenMore", GroupByNamePartDistributor.getPrefixWithLength("getEvenMoreWords", 3));
    Assert.assertEquals("1d", "get", GroupByNamePartDistributor.getPrefixWithLength("getEvenMoreWords", 1));
    Assert.assertEquals("1e", "getEvenMoreWords", GroupByNamePartDistributor.getPrefixWithLength("getEvenMoreWords", 4));

    Assert.assertEquals("2a", "get", GroupByNamePartDistributor.getPrefixWithLength("get", 1));
    Assert.assertEquals("2b", "get", GroupByNamePartDistributor.getPrefixWithLength("get", 2));
    Assert.assertEquals("2c", "get", GroupByNamePartDistributor.getPrefixWithLength("get", 3));
    Assert.assertEquals("2d", "g", GroupByNamePartDistributor.getPrefixWithLength("g", 2));
    Assert.assertEquals("2e", "-", GroupByNamePartDistributor.getPrefixWithLength("-", 2));

    Assert.assertEquals("3a", "get", GroupByNamePartDistributor.getPrefixWithLength("get-word", 1));
    Assert.assertEquals("3b", "get-more", GroupByNamePartDistributor.getPrefixWithLength("get-more-words", 2));
    Assert.assertEquals("3c", "get", GroupByNamePartDistributor.getPrefixWithLength("get-more-words", 1));
    Assert.assertEquals("3d", "get-more-words", GroupByNamePartDistributor.getPrefixWithLength("get-more-words", 3));

    Assert.assertEquals("4a", "get", GroupByNamePartDistributor.getPrefixWithLength("getBNFLength", 1));
    Assert.assertEquals("4b", "getBNF", GroupByNamePartDistributor.getPrefixWithLength("getBNFLength", 2));
    Assert.assertEquals("4c", "getBNFLength", GroupByNamePartDistributor.getPrefixWithLength("getBNFLength", 3));

  }

  public void testGetSuffixWithLength() {

    Assert.assertEquals("1a", "Words", GroupByNamePartDistributor.getSuffixWithLength("getWords", 1));
    Assert.assertEquals("1b", "MoreWords", GroupByNamePartDistributor.getSuffixWithLength("getMoreWords", 2));
    Assert.assertEquals("1c", "EvenMoreWords", GroupByNamePartDistributor.getSuffixWithLength("getEvenMoreWords", 3));
    Assert.assertEquals("1d", "Words", GroupByNamePartDistributor.getSuffixWithLength("getEvenMoreWords", 1));
    Assert.assertEquals("1e", "getEvenMoreWords", GroupByNamePartDistributor.getSuffixWithLength("getEvenMoreWords", 4));

    Assert.assertEquals("2a", "get", GroupByNamePartDistributor.getSuffixWithLength("get", 1));
    Assert.assertEquals("2b", "get", GroupByNamePartDistributor.getSuffixWithLength("get", 2));
    Assert.assertEquals("2c", "get", GroupByNamePartDistributor.getSuffixWithLength("get", 3));
    Assert.assertEquals("2d", "g", GroupByNamePartDistributor.getSuffixWithLength("g", 2));
    Assert.assertEquals("2e", "-", GroupByNamePartDistributor.getSuffixWithLength("-", 2));

    Assert.assertEquals("3a", "word", GroupByNamePartDistributor.getSuffixWithLength("get-word", 1));
    Assert.assertEquals("3b", "more-words", GroupByNamePartDistributor.getSuffixWithLength("get-more-words", 2));
    Assert.assertEquals("3c", "words", GroupByNamePartDistributor.getSuffixWithLength("get-more-words", 1));
    Assert.assertEquals("3d", "get-more-words", GroupByNamePartDistributor.getSuffixWithLength("get-more-words", 3));

    Assert.assertEquals("4a", "Length", GroupByNamePartDistributor.getSuffixWithLength("getBNFLength", 1));
    Assert.assertEquals("4b", "BNFLength", GroupByNamePartDistributor.getSuffixWithLength("getBNFLength", 2));
    Assert.assertEquals("4c", "getBNFLength", GroupByNamePartDistributor.getSuffixWithLength("getBNFLength", 3));
  }
}
